!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2003.02.02 ORSpecializedExit [Z, GLULX]
! Extends Exit/Take to support a few common exit commands.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
!----------------------------------------------------
! Modified behavior for exit.  Something that has 
! always bothered me.  With the below modifications, 
! "Exit balloon" or "get off table" or "get down from 
! the cabinet" or many other variations will work.
!--------------------------------------------------------------------------------------
! AutoDep:	
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#ifdef USE_ORSpecializedExit; #include "ORSpecializedExit"; #endif;
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_ORSpecializedExit; 
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2002.07.23	Initial Creation
! 2003.02.02	Modified grammar order, which trumped functionality of standard 
!				library's version of Exit.
!--------------------------------------------------------------------------------------
#ifdef USE_ORSpecializedExit;message "          Processing library extension ORSpecializedExit...";
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef ORSpecializedExit_DONEREPLACE; constant ORSpecializedExit_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef ORSpecializedExit_DONEMESSAGE; constant ORSpecializedExit_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! ORSpecializedExit requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef ORSpecializedExit_DONECODE;constant ORSpecializedExit_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef ORSpecializedExit_DONEGRAMMAR; constant ORSpecializedExit_DONEGRAMMAR; #ifdef ORSpecializedExit_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------
		Extend 'get' last
			* 'down'/'off'/'out' -> Exit
			* 'off' noun -> ExitNoun
			* 'off'/'out' 'of' noun -> ExitNoun
			* 'down' 'from' noun -> ExitNoun
		;
		Extend 'exit' last
			*	noun -> ExitNoun
		;
		ORLibMessage with body[;ExitNoun: 
			print (ig)CICant(actor)," exit ",(the)noun," since ",(IAm)actor," not standing ";
			if(noun has container) print "in"; else print "on";
			print_ret  " it.";
		];
		[ExitNounSub;
			if(noun~=parent(actor)) return L__M(action, 1);
			<<Exit>>;
		];

!--------------------------------------------------------------------------------------
#endif; #endif; #endif;